#include "IocpObject.h"

#include "IocpCommon.h"

#include "ObjectManager.h"
#include "SessionManager.h"
#include "Reactor.h"

#include "IocpThreadManager.h"
#include "IocpInterface.h"

/**
@brief .    new.
*/
CIocpObject::CIocpObject()
{
	new CObjectManager<CIocpInterface>;
	new CIocpThreadManager;
	new CSessionManager;
	new CReactor;
}

/**
@brief Ҹ. Ҹ   delete.
*/
CIocpObject::~CIocpObject()
{
	SAFE_DELETE_SINGLETON(CObjectManager<CIocpInterface>::GetInstancePtr());
	SAFE_DELETE_THREAD(CReactor::GetInstancePtr());
	SAFE_DELETE_SINGLETON(CSessionManager::GetInstancePtr());
	SAFE_DELETE_SINGLETON(CIocpThreadManager::GetInstancePtr());
}