﻿
#include "SocketInterface.h"

CWinSockObject CSocketInterface::m_WinSockObject;

/**
@brief 생성자. 소켓 인터페이스 초기화 작업을 한다
*/
CSocketInterface::CSocketInterface() : m_Socket(INVALID_SOCKET)
{
	m_SockAddrIn.sin_family = AF_INET;
	memset(m_SockAddrIn.sin_zero, 0, sizeof(m_SockAddrIn.sin_zero));
}

/*
@brief 소멸자. 릴리즈 메소드를 호출
*/
CSocketInterface::~CSocketInterface()
{
	//CloseSocket();
}

/**
@brief 소켓을 닫는 메소드
*/
bool CSocketInterface::CloseSocket()
{
	return ::CloseSocket(m_Socket);
}