#pragma once

#include "Peer.h"
#include "Singleton.h"

class CTestPeer : public CPeer, public CSingleton<CTestPeer>
{
public:
	CTestPeer();
	virtual ~CTestPeer();

	virtual void OnConnect();
	virtual void OnDisconnect();

	virtual int OnReceive(int nLen, void* data);

	virtual void Act();
};

inline CTestPeer* GetESPeer()
{
	return CTestPeer::GetInstancePtr();
}