#include "PacketGenerator.h"
#include "tinyxml.h"

bool CPacketGenerator::Generate(const tstring &strFileName)
{
	TiXmlDocument xmldoc(TCHAR_TO_CHAR(strFileName.c_str()));
	const TiXmlElement* elePacket = xmldoc.FirstChildElement("Packet");
	if( elePacket == NULL) return false;

	tstring strPacketName = TiAsTstring(elePacket, "Name");

	const TiXmlElement* eleParameterList = elePacket->FirstChildElement("ParameterList");
	while(eleParameterList)
	{
		const TiXmlElement* eleParameter = eleParameterList->FirstChildElement("Parameter");
		if(eleParameter)
		{
			tstring strParameterName = TiAsTstring(eleParameter, "Name");
			tstring strParameterType = TiAsTstring(eleParameter, "Type");
			long nByte = TiAsLong(eleParameter, "Byte");
		}
		
		eleParameterList = eleParameterList->NextSiblingElement();
	}	

	//const TiXmlElement* elePacketName = elePacket->FirstChildElement("Name");
	//if(elePacketName == NULL) return false;

	//const TiXmlElement* elePacketName = elePacket->FirstChildElement("Name");
	//if(elePacketName == NULL) return false;



	//const TiXmlElement* elePacket = xmldoc.FirstChildElement("Packet");
	//if( elePacket == NULL) return false;

	//const TiXmlElement* elePacket = xmldoc.FirstChildElement("Packet");
	//if( elePacket == NULL) return false;


	//<Packet Name = "LS_LOGIN_ACK">
	//	<ParameterList>
	//	<Parameter Name = "ErrorCode" Type = "eLoginResult" Byte = "1">
	//	</ParameterList>
	//	</Packet>	


	return true;
}