#pragma once

#include "Common.h"

#include "SmartSingleton.h"
#include "EventWorker.h"

class CPipe;
class CPipeContext : public OVERLAPPED_EX, public CSmartSingleton< CEventWorker<CPipeContext> >
{
public:
	CPipeContext(CPipe* pcPipe, IO_TYPE eIoType);

	virtual ~CPipeContext();

	IO_TYPE GetIOType(){return m_eIoType;}

	/**
	@brief WSAEvent ȯϴ ޼ҵ
	@return  WSAEVENT ڵ
	*/
	HANDLE GetEvent(){return hEvent;}

	void Register();

	/// ȣ  ҷ ޼ҵ
	void Proc();

private:

	IO_TYPE m_eIoType;
	CPipe* m_pcPipe;
};