﻿#pragma once

#include "EnvironmentManager.h"
#include "Singleton.h"
#include "Listener.h"
#include "Thread.h"
#include "IocpObject.h"
#include "AutoPtr.h"
#include "ManualPtr.h"

class CUDPSocket;

class CMain : public CEnvironmentManager , public CSingleton<CMain>, public CThread, public CIocpObject
{
	ELKY::CManualPtr<CListener> m_pcP2PRelayListener;
	ELKY::CAutoPtr<CUDPSocket> m_pcUDPSocket;

public:
	CMain(TCHAR* svrname);
	~CMain();

	virtual void Constructer();
	virtual void Run();
	virtual void Destructer();

	virtual void Act();

	void Stop();
};