#pragma once

#include <map>
#include "EnvironmentManager.h"
#include "singleton.h"
#include <memory>

#include "Config.h"
#include "IocpObject.h"

class CConnector;

class CMain : public CEnvironmentManager, public CIocpObject
{
	typedef std::map<int, CConnector*> STL_MAP_CONNECTOR;
	STL_MAP_CONNECTOR m_stl_map_Connector;

public:
	CMain(TCHAR* szProgramName);
	~CMain();

	virtual void Constructer();
	virtual void Run();
	virtual void Destructer();

	inline const std::string& GetIP(){return CConfig::GetInstancePtr()->GetIP();}
	inline const int& GetPort(){return CConfig::GetInstancePtr()->GetPort();}
};