#include "stdafx.h"
#include "Common.h"
#include "Main.h"
#include "TestPeer.h"
#include "Event.h"

CMain::CMain(TCHAR* szProgramName) : CEnvironmentManager(szProgramName)
{
	
}

CMain::~CMain()
{
	
}

void CMain::Constructer()
{
	CConnector::AllocThread(3);
	m_pcConnector.Reset(new CConnector(new CTestPeer, true));
	m_pcConnector->Set("192.168.11.17", 8000);
}

void CMain::Run()
{
	m_pcEvent->Wait(1000);

	m_pcConnector->Act();
	m_pcConnector->AliveCheck();
}

void CMain::Destructer()
{
}