#include "TestCommon.h"

#include "MemoryPool.h"
#include "CriticalSection.h"

typedef struct SEASYPoolData : public CMemoryPool<SEASYPoolData>
{
	int m_nData;
} SEASYPoolData; 

class CEASYPoolTest
{
public:
	CEASYPoolTest();
	~CEASYPoolTest();

private:
	SEASYPoolData* m_arrData[POOL_TEST_DATA_SIZE];
};

CEASYPoolTest::CEASYPoolTest()
{
	CMemoryManager::GetInstancePtr()->Alloc(sizeof(SEASYPoolData), POOL_TEST_DATA_SIZE);	
	for (int i = 0; i < POOL_TEST_DATA_SIZE; ++i)
	{
		m_arrData[i] = new SEASYPoolData;
	}
}

CEASYPoolTest::~CEASYPoolTest()
{
	for (int i = 0; i < POOL_TEST_DATA_SIZE; ++i)
	{
		delete m_arrData[i];
	}
}

TEST_FIXTURE(CEASYPoolTest, EASYPOOL_TEST)
{
}